From 87ce7b4a24f3b381a204ebd654050ac2c6bc2d14 Mon Sep 17 00:00:00 2001
From: KOSAKI Motohiro <kosaki.motohiro@jp.fujitsu.com>
Date: Fri, 20 Aug 2010 15:52:47 +0900
Subject: [PATCH 4/4] debug: zone_info reclaim_stat

Signed-off-by: KOSAKI Motohiro <kosaki.motohiro@jp.fujitsu.com>
---
 mm/vmstat.c |   27 +++++++++++++++++++++++++++
 1 files changed, 27 insertions(+), 0 deletions(-)

diff --git a/mm/vmstat.c b/mm/vmstat.c
index 7759941..bee3ba3 100644
--- a/mm/vmstat.c
+++ b/mm/vmstat.c
@@ -860,6 +860,33 @@ static void zoneinfo_show_print(struct seq_file *m, pg_data_t *pgdat,
 		   zone->prev_priority,
 		   zone->zone_start_pfn,
 		   zone->inactive_ratio);
+
+	{
+		extern int vm_swappiness;
+		int anon_prio = vm_swappiness;
+		int file_prio = 200 - vm_swappiness;
+		unsigned long ap;
+		unsigned long fp;
+		struct zone_reclaim_stat *reclaim_stat = &zone->reclaim_stat;
+
+		ap = (anon_prio + 1) * (reclaim_stat->recent_scanned[0] + 1);
+		ap /= reclaim_stat->recent_rotated[0] + 1;
+		fp = (file_prio + 1) * (reclaim_stat->recent_scanned[1] + 1);
+		fp /= reclaim_stat->recent_rotated[1] + 1;
+
+		seq_printf(m,
+			   "\n recent_anon_rotated: %lu"
+			   "\n recent_anon_scanned: %lu"
+			   "\n recent_file_rotated: %lu"
+			   "\n recent_file_scanned: %lu"
+			   "\n anon_ratio:          %lu"
+			   ,
+			   zone->reclaim_stat.recent_rotated[0],
+			   zone->reclaim_stat.recent_scanned[0],
+			   zone->reclaim_stat.recent_rotated[1],
+			   zone->reclaim_stat.recent_scanned[1],
+			   (ap * 100) / (ap + fp +1));
+	}
 	seq_putc(m, '\n');
 }
 
-- 
1.6.5.2

